# -*- coding: utf-8 -*-
#
# (c) 2008 by Intevation GmbH
# This is Free software under the GPLv3. 
# See LICENSE comming with the source of 'mpuls'
# for details.
#
# author: Torsten Irländer <torsten.irlaender@intevation.de>
import traceback
import psycopg2 as dbapi
import psycopg2.extensions
psycopg2.extensions.register_type(psycopg2.extensions.UNICODE)

#CONFIG = {'url': 'gruenkern.pult',
#          'port': 5432,
#          'dbname': 'waskoauswertung',
#          'nameschema': 'ka_%(dbname)s_db',
#          'userschema': 'ka_%(dbname)s_%(username)s',
#          'login': 'hannibal',
#          'password': '1q2w3e4r'}

CONFIG = {'url': None,
          'port': 5432,
          'dbname': 'waskoauswertung',
          'nameschema': '%(dbname)s',
          'userschema': '%(username)s',
          'login': 'postgres',
          'password': ''}

class DB:

    def __init__(self, dbname, user='postgres', password='', host=None, port=5432):
        self.dbname      = dbname 
        self.user        = user
        self.password    = password
        if password:
            self.password    = password.replace("\\", "\\\\")
        self.host        = host
        self.port        = int(port)
        self.conn        = None
        self.connections = []

    def getConnection(self):
        for used in self.connections:
            if not used[0]:
                used[0] = True
        try:
            if self.host:
                con = dbapi.connect(
                    database = self.dbname,
                    host     = self.host,
                    port     = self.port,
                    user     = self.user,
                    password = self.password)
            else:
                con = dbapi.connect(
                    database = self.dbname,
                    port     = self.port,
                    user     = self.user,
                    password = self.password)
            used = [True, con]
            self.connections.append(used)
            return con
        except:
            raise

    def recycleConnection(self, con, cur=None):
        if cur:
            try: cur.close()
            except: pass
        if con:
            for used in self.connections:
                if used[1] == con:
                    used[0] = False
                    return
            print >> sys.stderr, "WARNING: tried to recycle unused connection"

    def closeConnections(self):
        cons = self.connections
        self.connections = []
        for used in cons:
            if used[0]:
                print >> sys.stderr, "WARNING: Closing an unrecylcled connection"
            try:
                used[0].close()
            except:
                pass

def get_db(username, password, dbname, host, port):

    conn, cursor = None, None
    HOST    = host
    PORT    = port
    DBNAME  = CONFIG.get('nameschema')
    USER    = CONFIG.get('userschema')
    dbname  = dbname
    password = password
    username = username
    try:
        mydb = DB(
            dbname   = DBNAME % {'dbname': dbname },
            host     = HOST,
            port     = PORT,
            user     = USER % {'dbname': dbname, 'username': username},
            password = password)
        return mydb
    except StandardError, err:
        print traceback.print_exc()
        raise


# vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
